; Shifter - serial input module for BLINKENmini, LittleLights and BlinkenLeds
; output standard picture for LittleLights and BlinkenLeds
; version 0.1 date 2006-02-20
; Copyright (C) 2005-2006 Stefan Schuermans <1stein@schuermans.info>
; Copyleft: GNU public license - http://www.gnu.org/copyleft/gpl.html
; a BlinkenArea project - http://www.blinkenarea.org/



; image data for LL picture
OUT_PIC_DATA:
        .db     0x54, 0x98, 0xE0, 0x01, 0x00, 0x00
        .db     0x20, 0x01, 0x20, 0x01, 0x01, 0x00
        .db     0x08, 0x00, 0x09, 0x31, 0x00, 0x31
        .db     0x00, 0x01, 0x01, 0xAB, 0x67, 0x1F
        .db     0xAA, 0xCC, 0xF0, 0x00, 0x00, 0x00
        .db     0x08, 0x00, 0x08, 0x00, 0x00, 0x00
        .db     0x20, 0x00, 0x20, 0x18, 0x00, 0x18
        .db     0x00, 0x00, 0x00, 0x55, 0x33, 0x0F
        .db     0x01, 0x01, 0x01, 0x55, 0x33, 0x0F



; show LL picture
;  - uses: Y, Z, CNT, TMP
;  - used stack depth (without call to this function): 0
OUT_PIC:
        ldi     ZH,high(2*OUT_PIC_DATA)         ; load base address of image ("2*" to convert word address to byte address)
        ldi     ZL,low(2*OUT_PIC_DATA)
        mov     YH,OUT_PTR_RECV_H               ; get address of output buffer to put new data in
        mov     YL,OUT_PTR_RECV_L
        ldi     CNT,18*3
OUT_PIC_LOOP:
        lpm     TMP,Z+                          ; read byte from program memory
        st      Y+,TMP                          ; write byte to output buffer
        dec     CNT
        brne    OUT_PIC_LOOP
        rjmp    OUT_FLIP                        ; show new picture
