; Shifter - serial input module for BLINKENmini, LittleLights and BlinkenLeds
; main program file
; version 0.1 date 2006-02-20
; Copyright (C) 2005-2006 Stefan Schuermans <1stein@schuermans.info>
; Copyleft: GNU public license - http://www.gnu.org/copyleft/gpl.html
; a BlinkenArea project - http://www.blinkenarea.org/



; clock frequency: 12 MHz (external crystal)



; serial protocol: 115200, 8N1
;   input:
;     message-format: MCUF 18x8-1/256
;     message: <header> <data>
;     header: <magic> <height> <width> <channels> <maxval>
;     magic: 0x23 0x54 0x26 0x66
;     height: 0x00 0x08
;     width: 0x00 0x12
;     channels: 0x00 0x01
;     maxval: 0x00 0xFF
;     data: <line0> ... <line7>
;     line: <pixel0> ... <pixel17>
;     pixel: 0x00..0xFF
;   output:
;     message: (<snes0>|(0x80 0x00)) <snes1> <snes2> <snes3>
;     snes (bits): 0 0 <R> <L> <X> <A> <right> <left>   0 0 <down> <up> <start> <select> <Y> <B>



.INCLUDE        "tn2313def.inc"



.INCLUDE        "conf.inc"



.INCLUDE        "def_io.inc"

.INCLUDE        "def_reg.inc"



.DSEG
.ORG    0x060

.IF CONF_BM
.INCLUDE        "data_bm.inc"
.ENDIF

.IF CONF_LL
.INCLUDE        "data_ll.inc"
.ENDIF

.IF CONF_SNES
.INCLUDE        "data_snes.inc"
.ENDIF



.CSEG
.ORG    0x000

.INCLUDE        "code_vectors.inc"

.INCLUDE        "code_entry.inc"



.IF CONF_BM
.INCLUDE        "code_out_bm.inc"
.ENDIF

.IF CONF_LL
.INCLUDE        "code_out_ll.inc"
.ENDIF

.IF CONF_SNES
.INCLUDE        "code_in_snes.inc"
.ENDIF



.INCLUDE        "code_int.inc"



.INCLUDE        "code_flip.inc"



.IF CONF_BM
.INCLUDE        "code_pic_bm.inc"
.ENDIF

.IF CONF_LL
.INCLUDE        "code_pic_ll.inc"
.ENDIF



.INCLUDE        "code_store_common.inc"

.IF CONF_BM
.INCLUDE        "code_store_bm.inc"
.ENDIF

.IF CONF_LL
.INCLUDE        "code_store_ll.inc"
.ENDIF

.INCLUDE        "code_recv.inc"



.IF CONF_SNES
.INCLUDE        "code_trans.inc"
.ENDIF



.INCLUDE        "code_main.inc"
